=== modified file 'bzrlib/transport/sftp.py'
--- bzrlib/transport/sftp.py	2006-08-30 05:31:14 +0000
+++ bzrlib/transport/sftp.py	2006-08-30 06:19:59 +0000
@@ -197,12 +197,15 @@
         """Return the path to be passed along the sftp protocol for relpath.
         
         relpath is a urlencoded string.
+
+        :return: a path prefixed with / for regular abspath-based urls, or a
+            path that does not begin with / for urls which begin with /~/.
         """
         # FIXME: share the common code across transports
         assert isinstance(relpath, basestring)
         basepath = self._path.split('/')
         if relpath.startswith('/'):
-            basepath = []
+            basepath = ['', '']
         relpath = urlutils.unescape(relpath).split('/')
         if len(basepath) > 0 and basepath[-1] == '':
             basepath = basepath[:-1]
@@ -216,13 +219,11 @@
                 basepath.pop()
             elif p == '.':
                 continue # No-op
-            else:
+            elif p != '':
                 basepath.append(p)
 
         path = '/'.join(basepath)
         # mutter('relpath => remotepath %s => %s', relpath, path)
-        if path == '':
-            path = '/'
         return path
 
     def relpath(self, abspath):
@@ -600,6 +601,7 @@
         return SFTPLock(relpath, self)
 
     def _unparse_url(self, path=None):
+        """Gives a url for a relative reference."""
         if path is None:
             path = self._path
         path = urllib.quote(path)

